/*****************************************************************************
 * Date: 20100105
 * Author: Mario Roessler, DH5YM
 * License: GNU General Public License
 * Description: DCF77 Decoder
 * file: dcf77d.h
 *
 *
 *****************************************************************************/

 /* Todo:
  * - configure and test DCF77 signal input without hardware buffer
  * - change second synchronization to pinchange interrupt based (done, 2010/01/13)
  * 
  */

//Defines
#define DCF77_PORT PORTD
#define DCF77_PIN  2

//Defines for debugging
//#define dcf77debug  //dcf77 decoder debugging prints on/off (just define dcf77debug OR debufclock !)
#define debugclock  //clock debug prints on/off
#define debugled  //debug LEDs on/off

//variables for dcf77 decoder
volatile uint8_t dcfsample;
volatile uint8_t dcfbufcnt;
volatile uint8_t dcfones;
volatile uint8_t dcfzeros;

static volatile uint8_t bitone=0,zerocount=0,testone=0;
volatile uint8_t datagram[8];
volatile uint8_t datagrambuf[8];
static volatile uint8_t validbits=0;  //count of received bits per datagram

//variables for clock
static volatile uint16_t milisecond=0;
static volatile uint16_t msoffset;
static volatile uint8_t second=0;
static volatile uint8_t minute=0;
static volatile uint8_t hour=0;
static volatile uint8_t day=0;
static volatile uint8_t month=0;
static volatile uint16_t year=0;
static volatile uint8_t dcf77sync=254; //maximum value = 254, 255=reset counter
#ifdef debugclock
static volatile uint8_t lastsecond=255;
#endif

/* 
** constants/macros (copied from LCD library)
*/
#define DDR(x) (*(&x - 1))      /* address of data direction register of port x */
#if defined(__AVR_ATmega64__) || defined(__AVR_ATmega128__)
    /* on ATmega64/128 PINF is on port 0x00 and not 0x60 */
    #define PIN(x) ( &PORTF==&(x) ? _SFR_IO8(0x00) : (*(&x - 2)) )
	#define PORT(x) (*(&x))
#else
	#define PIN(x) (*(&x - 2))    /* address of input register of port x          */
	#define PORT(x) (*(&x))
#endif

/*
** function prototypes
*/
//functions for dcf77 decoder
extern void dcf77_init(void);
extern void int0pci_init(void);
extern void int0pci_off(void);
extern void dcf77_demodulate(void);
extern void dcf77_decode(void);
void dcf77_printarray(void);
uint8_t getbitfrombuf(uint8_t bitnum);
//functions for clock
extern void clock(void);
void printclock(void);
void setclock(void);
